import numpy as np
from collections import Counter


#finding the distance
def euclidean_distance(x1, x2):
    distance = np.sqrt(np.sum((x1-x2)**2))
    return distance


class KNN:
    def __init__(self, k=3):
        self.k = k


    #learning function
    def fit(self, X, y):
        self.X_train = X
        self.y_train = y


    #prediction function
    def predict(self, X):
        predictions = [self._predict(x) for x in X]
        return predictions


    #healper predict, where closest points are found
    def _predict(self, x):
        
        distances = [euclidean_distance(x, x_train) for x_train in self.X_train]
    
        k_indices = np.argsort(distances)[:self.k]
        k_nearest_labels = [self.y_train[i] for i in k_indices]

        most_common = Counter(k_nearest_labels).most_common()
        return most_common[0][0]